CREATE OR REPLACE FUNCTION assoc_rules(varchar,int) RETURNS SETOF rules AS '
DECLARE
	associator	ALIAS FOR $1;
	size		ALIAS FOR $2;
	
	max_tam		integer := 0;
	val_ext		integer;
	cont_reg	integer;
	ini		integer;
	fin		integer;
	i		integer;
	f		integer;
	j		integer;
	cont		integer;
		
	qry_sql		text DEFAULT '''';
	cad_att		text DEFAULT NULL;
	flag_val	text DEFAULT NULL;
		
	rec_at		record;
	rec_expr	rules%ROWTYPE;
	
BEGIN
	--****	GENERA CADENA DE ATRIBUTOS associator 
	
	qry_sql := ''SELECT pg_class.oid as oid,attname,attnum,relnatts FROM pg_class, pg_attribute'';
	qry_sql := qry_sql || '' WHERE pg_class.relname = ''''''||associator||'''''''';
	qry_sql := qry_sql || '' AND pg_attribute.attrelid = pg_class.oid'';
	qry_sql := qry_sql || '' AND attnum > 0 AND attnum < relnatts ORDER BY attnum'';
	
	FOR rec_at IN EXECUTE qry_sql LOOP
		
		IF cad_att ISNULL THEN cad_att := rec_at.attname;
		ELSE cad_att := cad_att ||'' , ''|| rec_at.attname;
		END IF;
		
	END LOOP;
	--****
	
	
	--****	CREA TABLA TEMPORAL DE TAMANOS dar_size
	
	IF size > rec_at.relnatts THEN
		RAISE EXCEPTION ''SIZE % sobrepasa el numero de atributos de %, size deberia ser menor de %'',size,associator,rec_at.relnatts;
		RETURN;
	END IF;
		
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''dar_size'';
	IF flag_val ISNULL THEN
		qry_sql := ''CREATE TEMP TABLE dar_size AS SELECT oid as codigo, size_rules(''''''||associator||'''''') as fq 
				FROM ''||associator;
		EXECUTE qry_sql;
	END IF; 
	
	SELECT INTO max_tam max(fq) from dar_size;
	IF size > max_tam THEN
		RAISE EXCEPTION ''La tabla de ASOCIACION %, no cumple con el tamano %'',associator,size;
		RETURN;
	END IF;
	--****

	
	--****	CREA TABLA TEMPORAL DE ASOCIACION dar_rasso SEGUN TAMANO size
	
	SELECT INTO flag_val relname FROM pg_class WHERE relname = ''dar_rasso'';
	IF flag_val ISNULL THEN
		qry_sql := ''CREATE TABLE dar_rasso AS 
				SELECT * FROM (SELECT ''||cad_att||'' FROM ''||associator||'', dar_size 
						WHERE dar_size.fq = ''||size||'' 
						AND ''||associator||''.oid = dar_size.codigo) AS rules_can
				ASSOCIATOR RANGE 1 UNTIL ''||rec_at.attnum||'''';
				
		EXECUTE qry_sql;
		
		EXECUTE ''ALTER TABLE dar_rasso ADD COLUMN n_regla int2'';
		EXECUTE ''ALTER TABLE dar_rasso ADD COLUMN implica char(1)'';
		EXECUTE ''ALTER TABLE dar_rasso ADD COLUMN confianza numeric(5,2)'';
	END IF;
	--****
	
	
	--****	GENERA REGLAS CANDIDATAS DE ASOCIACION
	
	SELECT INTO ini oid as cod FROM dar_rasso;
	SELECT INTO cont_reg count(*) FROM dar_rasso;
	val_ext := (2 ^ size) - 1;
	fin := ini + (val_ext - 2);
	i := ini;
	f := fin;
	
	cont := 1;
	j := 0;
	WHILE j < cont_reg LOOP
		
		WHILE ini <= fin LOOP
		
			SELECT INTO rec_expr * FROM dar_rasso WHERE oid = ini; 
			rec_expr.n_regla := cont;
			rec_expr.implica := ''A'';
			RETURN NEXT rec_expr;
			ini := ini + 1;
			
			SELECT INTO rec_expr * FROM dar_rasso WHERE oid = f; 
			rec_expr.n_regla := cont;
			rec_expr.implica := ''C'';
			RETURN NEXT rec_expr;
			f := f - 1;
			
			cont := cont + 1;
	
		END LOOP;
		
		ini := i + val_ext;
		fin := ini + (val_ext - 2);
		i := ini;
		f := fin;
		
		j := j + val_ext;
		
	END LOOP;
	--****
	RETURN;
END;'
LANGUAGE 'plpgsql' WITH (isstrict);
